#!/bin/bash
#used to setup reporting 

#Usage :
	# Between dates :	
	# python query_builder.py -s "01.12.2016 00:00:00" -e "07.02.2017 00:00:00"
	# Particular date
	# python query_builder.py -t day -d "05.02.2017"
	# Hour based 
# python query_builder.py

SRC_DIR_1="api/"
DST_DIR_1="/usr/local/safesquid"
SRC_DIR_2="report/"
DST_DIR_2="/usr/local/safesquid/ui_root"

LOG_FILE="/tmp/reporting.log"
GENERATE_SH="${DST_DIR_1}/api/generate.sh"

LOG_IT(){
	echo "[`date`] - ${*}" | tee -a ${LOG_FILE}
}

CHECK_DIR(){
	[ ! -d $1 ] && mkdir -p $1
}

CRON_ENTRY(){
	
	cat << _EOF > ${GENERATE_SH}
#!/bin/bash	
	
/usr/bin/python /usr/local/safesquid/api/query_builder.py -t day -d \`date --date="1 days ago" "+%d.%m.%Y"\`
_EOF
	
	chmod 755 ${GENERATE_SH}	
	
	CRONETY=$(cat /etc/crontab | grep ${GENERATE_SH} | wc -l)
	
	if [ "x${CRONETY}" == "x0" ];then
		echo "20 1 * * * root /bin/bash ${GENERATE_SH}" >> /etc/crontab
		/etc/init.d/cron restart
	fi
	
}

SRC_CPY(){
	LOG_IT "Copying handler source to ${DST_DIR_1}.."	
	CHECK_DIR ${DST_DIR_1}
	cp -r ${SRC_DIR_1} ${DST_DIR_1}	 
	
	LOG_IT "Copying html source to ${DST_DIR_2}.."	
	CHECK_DIR ${DST_DIR_2}
	cp -r ${SRC_DIR_2} ${DST_DIR_2}	 
}

GENERATE(){
	DATE=`date +%d.%m.%Y`
	/usr/bin/python /usr/local/safesquid/api/query_builder.py -t day -d "${DATE}"
}

MAIN(){
	SRC_CPY
	GENERATE
	CRON_ENTRY
}

MAIN
exit 0